
package de.ivu.elect.presentation.stimmeingabe.menu;

import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.boundary.plausi.StimmeingabePlausiDefinitionsResolver;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.stimmeingabe.StimmeingabePlausiKonfigurationSearchView;

public class StimmeingabePlausiKonfigurationSearchMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlSessionSelect wahlSelect;

  @Inject
  private transient StimmeingabePlausiDefinitionsResolver stimmeingabePlausiDefinitionsResolver;

  public StimmeingabePlausiKonfigurationSearchMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.STIMMEINGABE_PLAUSI_SEARCH) && stimmeingabePlausiDefinitionsResolver.findStimmeingabePlausiDefinitions(getSelectedWahl()).isPresent();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isDisabledInternal() {
    return !isWahlSelected();
  }

  @Override
  public String getTargetViewId() {
    return StimmeingabePlausiKonfigurationSearchView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "stimmeingabe.plausi.konfiguration.search.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconSearch();
  }

  private boolean isWahlSelected() {
    return wahlSelect.isSelected();
  }

  private Wahl getSelectedWahl() {
    return wahlSelect.getEntity();
  }
}
